INPUT m
LET n=m^2
DIM a(n,n),p(n+1), b(n,n), ith(n)

LET EPS=1.e-9

CALL SetFtherm(a,m)

PRINT " A matrix n=";n
CALL matprt(a,n,n)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
CALL elmhes(a,n)
PRINT " H matrix n=";n
CALL matprt(a,n,n)

CALL nmhes(a,n,ith,nmat)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
FOR k=nmat TO 1 STEP -1
   LET i2=ith(k)
   IF k>1 THEN
      LET i1 = ith(k-1)+1
   ELSE
      LET i1=1
   END IF
   PRINT
   PRINT "SUB MATRIX ";k
   PRINT
   PRINT " Hessenberg matrix size=";i2-i1+1;" i1=";i1;" i2=";i2
   LET nsize=i2-i1+1
    
   FOR j=1 to nsize
      FOR i=1 to nsize
         LET b(i,j)=a(i+i1-1,j+i1-1)
      NEXT i
   NEXT j
    
   CALL hesfrb(b,nsize,p)
   !PRINT " Frobenius matrix n=";nsize
   PRINT " X matrix n=";nsize
    
   FOR i=1 TO nsize+1
      PRINT p(i);
   NEXT i
   PRINT 
NEXT k
 
END

EXTERNAL SUB elmhes(a(,),n)
FOR m=2 TO n-1
!!!!!!!!!!!!!!!
   LET x=0
   LET i=m
   FOR j=m TO n
      IF ABS(a(j,m-1)) > ABS(x) THEN
         LET x=a(j,m-1)
         LET i=j
      END IF
   NEXT j
   IF i<>m THEN
      FOR j=m-1 TO n
         LET y=a(i,j)
         LET a(i,j)=a(m,j)
         LET a(m,j)=y
      NEXT j  
      FOR j=1 TO n
         LET y=a(j,i)
         LET a(j,i)=a(j,m)
         LET a(j,m)=y
      NEXT j  
   END IF
   !!!!!!!!!!!!!!!
   IF x <> 0 THEN
      FOR i=m+1 TO n
         LET y=a(i,m-1)
         IF y <> 0 THEN
            LET y=y/x
            PRINT "i=";i;"x=";x;"y=";y
            LET a(i,m-1)=y
            FOR j=m TO n
               PRINT "i,j=";i;j;"a(i,j)=";a(i,j);"=>";
               LET a(i,j)=a(i,j)-y*a(m,j)
               PRINT a(i,j);
            NEXT j
            PRINT
            FOR j=1 TO n
               PRINT "j,m=";j;m;"a(j,m)=";a(j,m);"=>";
               LET a(j,m)=a(j,m)+y*a(j,i)
               PRINT a(j,m);
            NEXT j
            print
         END IF
         LET a(i,m-1)=0 
      NEXT i
   END IF 
   PRINT "elmhes m=";m
   CALL matprt(a,n,n)
NEXT m 
END SUB

EXTERNAL SUB nmhes(a(,),n,ith(),nmhes)
LET j=1
FOR i=2 TO n
   IF a(i,i-1)=0 THEN 
      LET ith(j)=i-1
      !PRINT "nmhes j=";j;"  ith=";ith(j)
      LET j=j+1
   END IF
NEXT i
LET ith(j)=n
!PRINT "nmhes j=";j;"  ith=";ith(j)
LET nmhes=j
END SUB


EXTERNAL SUB hesfrb(a(,),n,p())
 
FOR k=1 TO n-1
   FOR i=1 TO k
      LET p(i)=a(i,k)/a(k+1,k)
      LET a(i,k)=0
   NEXT i
    
   FOR j=k+1 TO n
      FOR i=1 TO k
         LET a(i,j)=a(i,j)-p(i)*a(k+1,j)
      NEXT i
   NEXT j
    
   FOR i=2 TO k+1
      LET a(i,k+1)=a(i,k+1)+p(i-1)*a(i,i-1)
   NEXT i
NEXT k
 
LET t=1 
FOR i=n TO 2 step -1
   LET p(n-i+2)=a(i,n)*t
   LET t=t*a(i,i-1)
NEXT i
LET p(n+1)=t*a(1,n)
 
LET p(1)=-1
IF MOD(n,2)=0 THEN
   FOR i=1 TO n+1
      LET p(i)=-p(i)
   NEXT i
END IF
END SUB


EXTERNAL SUB SetFtherm(a(,),m)
MAT a=ZER
FOR i=1 TO m
   IF i-1 => 1 THEN LET a(i,i-1)=-1
   LET a(i,i)=4
   IF MOD(i,m) <> 0 THEN LET a(i,i+1)=-1
   LET a(i,i+m)=-1
NEXT i
FOR i=m+1 TO m*(m-1)
   LET a(i,i-m)=-1
   IF MOD(i,m) <> 1 THEN LET a(i,i-1)=-1
   LET a(i,i)=4
   IF MOD(i,m) <> 0 THEN LET a(i,i+1)=-1
   LET a(i,i+m)=-1
NEXT i
FOR i=m*(m-1)+1 TO m*m 
   LET a(i,i-m)=-1
   IF MOD(i,m) <> 1 THEN LET a(i,i-1)=-1
   LET a(i,i)=4
   IF MOD(i,m) <> 0 THEN LET a(i,i+1)=-1
NEXT i
END SUB
 
EXTERNAL SUB MATPRT(a(,),m,n)
FOR i=1 TO m
   FOR j=1 TO n-1
   ! PRINT using "-%.###^^^^":A(i,j);
      PRINT a(i,j);
   NEXT j
   !  PRINT using "-%.###^^^^":A(i,n)
   PRINT a(i,n)
NEXT i
END SUB
